exec("./support.cs");

new GuiScrollCtrl(CustomGameGui_SearchScroll)
{
	profile = "ImpactScrollProfile";
	horizSizing = "relative";
	vertSizing = "relative";
	position = "160 39";
	extent = "480 411";
	minExtent = "8 2";
	enabled = true;
	visible = false;
	clipToParent = true;
	willFirstRespond = false;
	hScrollBar = "alwaysOff";
	vScrollBar = "alwaysOn";
	constantThumbHeight = false;
	childMargin = "0 0";
	rowHeight = 81;
	columnWidth = 30;

	new GuiSwatchCtrl(CustomGameGui_SearchBox)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "bottom";
		position = "0 0";
		extent = "459 411";
		minExtent = "8 2";
		enabled = true;
		visible = true;
		clipToParent = true;
		color = "0 0 0 0";
	};
};

CustomGameGui.add(CustomGameGui_SearchScroll);

new GuiTextCtrl(CustomGameGui_SearchBoxBackground)
{
	profile = "ImpactTextProfile";
	horizSizing = "relative";
	vertSizing = "relative";
	position = "470 0";
	extent = "80 33";
	minExtent = "8 2";
	enabled = true;
	visible = true;
	clipToParent = true;
	text = "Search...";
	maxLength = 255;
};

CustomGameGui.add(CustomGameGui_SearchBoxBackground);

new GuiTextEditCtrl(CustomGameGui_SearchEdit)
{
	profile = "ImpactEditProfile";
	horizSizing = "relative";
	vertSizing = "relative";
	position = "470 0";
	extent = "80 33";
	minExtent = "8 2";
	enabled = true;
	visible = true;
	clipToParent = true;
	command = "CustomGameGui_SearchEdit.type(CustomGameGui_SearchEdit.getValue());";
	maxLength = 255;
	historySize = 0;
	password = false;
	tabComplete = false;
	sinkAllKeyEvents = false;
};

CustomGameGui.add(CustomGameGui_SearchEdit);

function CustomGameGui_SearchEdit::onWake(%obj)
{
	%obj.setExtent(firstWord(CustomGameGui.getExtent()) - firstWord(%obj.getPosition()) SPC getWord(%obj.getExtent(), 1));

	if(!%obj.hasWoken)
	{
		%obj.hasWoken = true;
		%count = CustomGameGui.getCount();

		for(%i = 0; %i < %count; %i++)
		{
			%obj = CustomGameGui.getObject(%i);
			%name = %obj.getName();

			if(%name $= "" || strLen(%name) <= 21 || getSubStr(%name, 0, 14) !$= "CustomGameGui_" || getSubStr(%name, strLen(%name) - 7, 7) !$= "Hilight")
			{
				continue;
			}

			if(isObject(%btn = "CustomGameGui_" @ getSubStr(%name, 14, strLen(%name) - 21) @ "Button"))
			{
				%btn.command = %btn.command @ "CustomGameGui_SearchEdit.cancelSearch();";

				if(%btn.getName() $= "CustomGameGui_AdvancedButton")
				{
					%btn.command = %btn.command @ "CustomGameGui_SearchBoxBackground.setVisible(0);";
				}
			}
		}
	}
}

function CustomGameGui_SearchEdit::onSleep(%obj)
{
	%obj.cancelSearch();
}

function CustomGameGui_SearchEdit::type(%searchBox, %text)
{
	if(strLen(%text) >= 2)
	{
		%prevText = getSubStr(%text, 0, strLen(%text) - 1);
	}

	else
	{
		%prevText = "";
	}

	CustomGameGui_SearchBox.deleteAll();

	%bool = %text $= "" ? true : false;
	%scroll = CustomGameGui.getActiveTabScrollObj();
	%tab = %scroll.getObject(0);

	if(%scroll.getName() $= "CustomGameGui_AddOnsScroll")
	{
		%text = strReplace(%text, " ", "_");
		%searchBox.setText(%text);
	}

	%scroll.setVisible(%bool);
	CustomGameGui_SearchBoxBackground.setVisible(%bool);
	CustomGameGui_SearchScroll.setVisible(!%bool);

	if(%text $= "")
	{
		return;
	}

	%count = %tab.getCount();

	//First search. Find things starting with %text.
	for(%i = 0; %i < %count; %i++)
	{
		%obj = %tab.getObject(%i);

		if(isFunction(%obj.getClassName(), "getText"))
		{
			%val = stripMLControlChars(LTrim(%obj.getText()));
		}

		else
		{
			continue;
		}

		if(strLen(%val) >= strLen(%text) && getSubStr(%val, 0, strLen(%text)) $= %text)
		{
			%posY = CustomGameGui_SearchBox.getCount() ? getWord(CustomGameGui_SearchBox.getObject(CustomGameGui_SearchBox.getCount() - 1).getPosition(), 1) + getWord(CustomGameGui_SearchBox.getObject(CustomGameGui_SearchBox.getCount() - 1).getExtent(), 1) : 0;

			%prevName = %obj.getName();
			%obj.setName("TempCopyCtrl");

			%newObj = eval("%ctrl = new" SPC %obj.getClassName() @ "(: TempCopyCtrl) { text = \"\"; }; return %ctrl;");

			%newObj.position = firstWord(%obj.getPosition()) SPC %posY;
			%newObj.command = %obj.command @ %obj.getID() @ ".setValue(" @ %newObj.getID() @ ".getValue());";

			%textObj = new GuiMLTextCtrl(: TempCopyCtrl)
			{
				profile = "ImpactTextProfile";
				position = firstWord(%newObj.getPosition()) + 40 SPC %posY;
				extent = firstWord(%obj.getExtent()) SPC "27";
				lineSpacing = 2;
				allowColorChars = true;
				maxChars = -1;
				text = setSubStr(%val, strLen(%text), 0, "<color:afbebe>");
				maxBitmapHeight = -1;
				selectable = false;
				autoResize = true;
			};

			CustomGameGui_SearchBox.add(%textObj);
			CustomGameGui_SearchBox.add(%newObj);

			%obj.setName(%prevName);
		}
	}

	//Second search. Find things containing, but not starting with %text.
	for(%i = 0; %i < %count; %i++)
	{
		%obj = %tab.getObject(%i);

		if(isFunction(%obj.getClassName(), "getText"))
		{
			%val = stripMLControlChars(LTrim(%obj.getText()));
		}

		else
		{
			continue;
		}

		%strPos = striPos(%val, %text);

		if(strLen(%val) >= strLen(%text) && %strPos > 0)
		{
			%posY = CustomGameGui_SearchBox.getCount() ? getWord(CustomGameGui_SearchBox.getObject(CustomGameGui_SearchBox.getCount() - 1).getPosition(), 1) + getWord(CustomGameGui_SearchBox.getObject(CustomGameGui_SearchBox.getCount() - 1).getExtent(), 1) : 0;

			%prevName = %obj.getName();
			%obj.setName("TempCopyCtrl");

			%newObj = eval("%ctrl = new" SPC %obj.getClassName() @ "(: TempCopyCtrl) { text = \"\"; }; return %ctrl;");

			%newObj.position = firstWord(%obj.getPosition()) SPC %posY;
			%newObj.command = %obj.command @ %obj.getID() @ ".setValue(" @ %newObj.getID() @ ".getValue());";

			%textObj = new GuiMLTextCtrl(: TempCopyCtrl)
			{
				profile = "ImpactTextProfile";
				position = firstWord(%newObj.getPosition()) + 40 SPC %posY;
				extent = firstWord(%obj.getExtent()) SPC "27";
				lineSpacing = 2;
				allowColorChars = true;
				maxChars = -1;
				text = "<sPush><color:afbebe>" @ getSubStr(%val, 0, %strPos) @ "<sPop>" @ getSubStr(%val, %strPos, strLen(%text)) @ "<color:afbebe>" @ getSubStr(%val, %strPos + strLen(%text), strLen(%val) - (%strPos + strLen(%text)));
				maxBitmapHeight = -1;
				selectable = false;
				autoResize = true;
			};

			CustomGameGui_SearchBox.add(%textObj);
			CustomGameGui_SearchBox.add(%newObj);

			%obj.setName(%prevName);
		}
	}

	if(CustomGameGui_SearchBox.getCount())
	{
		%lastObj = CustomGameGui_SearchBox.getObject(CustomGameGui_SearchBox.getCount() - 1);

		CustomGameGui_SearchBox.setExtent(firstWord(CustomGameGui_SearchBox.getExtent()) SPC getWord(%lastObj.getPosition(), 1) + getWord(%lastObj.getExtent(), 1));
	}

	else
	{
		CustomGameGui_SearchBox.setExtent(firstWord(CustomGameGui_SearchBox.getExtent()) SPC getWord(CustomGameGui_SearchScroll.getExtent(), 1));
	}
}

function CustomGameGui_SearchEdit::cancelSearch(%obj)
{
	CustomGameGui_SearchBoxBackground.setVisible(1);
	%obj.setText("");
	CustomGameGui_SearchScroll.setVisible(0);
}

function CustomGameGui::getActiveTabScrollObj(%gui)
{
	%count = %gui.getCount();

	for(%i = 0; %i < %count; %i++)
	{
		%obj = %gui.getObject(%i);
		%name = %obj.getName();

		if(%name $= "" || strLen(%name) <= 21 || getSubStr(%name, 0, 14) !$= "CustomGameGui_" || getSubStr(%name, strLen(%name) - 7, 7) !$= "Hilight")
		{
			continue;
		}

		if(%obj.isVisible())
		{
			%tab = "CustomGameGui_" @ getSubStr(%name, 14, strLen(%name) - 21) @ "Scroll";

			if(!isObject(%tab))
			{
				%tab = "CustomGameGui_" @ getSubStr(%name, 14, strLen(%name) - 21) @ "Window";
			}

			if(isObject(%tab))
			{
				return %tab;
			}
		}
	}

	return 0;
}